//
// Patron pour la generation d'une classe derivee dans ROOT
// FFileFasterDataReader derive de FFasterDataReader
//

#ifndef FFileFasterDataReader_h
#define FFileFasterDataReader_h

#include "FFasterDataReader.h"

class FFileFasterDataReader : public FFasterDataReader {

  public:
    FFileFasterDataReader(void);    // constructeur par defaut
    FFileFasterDataReader(const FFileFasterDataReader &ap); // constructeur par copie
    ~FFileFasterDataReader(void);		// desctructeur;
    virtual Int_t GetNextEvent(void);

#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
    virtual void Copy(TObject & obj) const;
#else
    virtual void Copy(TObject & obj);
#endif
    FFileFasterDataReader& operator = (const FFileFasterDataReader &hp); // operateur =

    ClassDef(FFileFasterDataReader,1)

};

#endif

