//
// Patron pour la generation d'une classe derivee dans ROOT
// FHMultiParam1D derive de TH2D
//

#ifndef FHMultiParam1D_h
#define FHMultiParam1D_h

#include "TH1D.h"
#include "FMultiParam1DAtt.h"

class FHMultiParam1D : public TH1D, public FMultiParam1DAtt {

  protected:
    virtual void Init(void);       // initialisation

  public:
    FHMultiParam1D(void);    // constructeur par defaut
    FHMultiParam1D(const char* name, const char* title);
    FHMultiParam1D(const char* name, const char* title,
        Int_t n, Double_t min,Double_t max);
    FHMultiParam1D(const FHMultiParam1D &ap); // constructeur par copie

    ~FHMultiParam1D(void);		// desctructeur;

#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
    virtual void Copy(TObject & obj) const;
#else
    virtual void Copy(TObject & obj);
#endif
    FHMultiParam1D& operator = (const FHMultiParam1D &hp); // operateur =

    virtual TH1 *GetHisto(void);
    virtual void SavePrimitive(ostream &out, Option_t *opt="");

    virtual void Paint(Option_t *option="");
    virtual void ToggleActivate(Int_t val=1) {FHistAtt::ToggleActivate(val);} // *TOGGLE* *GETTER=IsActivated
    virtual void ToggleCanRebin(Int_t val=1) {FHistAtt::ToggleCanRebin(val);} // *TOGGLE* *GETTER=CanRebin

    ClassDef(FHMultiParam1D,1)

};

#endif

