// 
// Patron pour la generation d'une classe derivee dans ROOT
// MFH1GUI derive de MHistoGUI
// 
 
#ifndef MFH1GUI_h 
#define MFH1GUI_h 
 
#include "MHistoGUI.h"
#include "MGAxe.h"
 
class MFH1GUI : public MHistoGUI { 

 
   public:	 
	MGAxe *varX;

   public:	 
	MFH1GUI(const TGWindow *p=0,UInt_t w=500,UInt_t h=300);
#if ROOT_VERSION_CODE <= ROOT_VERSION(5,12,0)
	MFH1GUI(const MFH1GUI &ap); // constructeur par copie 
#endif
	
	~MFH1GUI(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	MFH1GUI& operator = (const MFH1GUI &hp); // operateur = 
 
	virtual Bool_t ProcessMessage(Long_t msg, Long_t par1, Long_t par2); 

	virtual void SetHistogramProperties(void);
	virtual void ReadHistogramProperties(void);

	virtual void Reset(void);

    ClassDef(MFH1GUI,1)
 
}; 
 
#endif 
 
