// 
// Patron pour la generation d'une classe derivee dans ROOT
// MFTime2DGUI derive de MHistoGUI
// 
 
#ifndef MFTime2DGUI_h 
#define MFTime2DGUI_h 
 
#include "MHistoGUI.h"
#include "MGAxe.h"
 
class MFTime2DGUI : public MHistoGUI { 

 
   public:	 
	TGNumberEntry	*nbBins;
	TGNumberEntry	*secPerBin;
	MGAxe *var;

   public:	 
	MFTime2DGUI(const TGWindow *p=0,UInt_t w=500,UInt_t h=300);
#if ROOT_VERSION_CODE <= ROOT_VERSION(5,12,0)
	MFTime2DGUI(const MFTime2DGUI &ap); // constructeur par copie 
#endif
	
	~MFTime2DGUI(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	MFTime2DGUI& operator = (const MFTime2DGUI &hp); // operateur = 
 
	virtual Bool_t ProcessMessage(Long_t msg, Long_t par1, Long_t par2); 

	virtual void SetHistogramProperties(void);
	virtual void ReadHistogramProperties(void);

	virtual void Reset(void);

    ClassDef(MFTime2DGUI,1)
 
}; 
 
#endif 
 
