// 
// Patron pour la generation d'une classe derivee dans ROOT
// MFileDeviceGUI derive de MDeviceGUI
// 
 
#ifndef MFileDeviceGUI_h 
#define MFileDeviceGUI_h 
 
#include "MDeviceGUI.h"
#include "MTELabel.h"
 
class MFileDeviceGUI : public MDeviceGUI { 

   protected:
   	MTELabel *fileName;
   	MTELabel *blockSize;

   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
	MFileDeviceGUI(const TGWindow *p=0,UInt_t w=500,UInt_t h=300);
#if ROOT_VERSION_CODE <= ROOT_VERSION(5,12,0)
	MFileDeviceGUI(const MFileDeviceGUI &ap); // constructeur par copie 
#endif
	
	~MFileDeviceGUI(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	MFileDeviceGUI& operator = (const MFileDeviceGUI &hp); // operateur = 
 
	virtual Bool_t ProcessMessage(Long_t msg, Long_t par1, Long_t par2); 

	virtual void SetDeviceProperties(void);
	virtual void ReadDeviceProperties(void);

	virtual void Reset(void);

    ClassDef(MFileDeviceGUI,1)
 
}; 
 
#endif 
 
