// 
// Patron pour la generation d'une classe derivee dans ROOT
// MGenericHistogramBuilderGUI derive de TGCompositeFrame
// 
 
#ifndef MGenericHistogramBuilderGUI_h 
#define MGenericHistogramBuilderGUI_h 
 
#include "TROOT.h"
#include "TGClient.h"
#include "FEventProcessor.h" 
#include "MCBLabel.h" 
#include "MTELabel.h" 
#include "MGAxe.h" 
 
class MGenericHistogramBuilderGUI : public TGCompositeFrame { 

	enum ElementId 
	{
	 CB_Name,
	 CB_Title,
	 CB_loHC,
	 CB_Condition
	};
 
   protected: 
	FEventProcessor		*fept;
	MCBLabel		*histoName;
	MCBLabel		*histoTitle;
	MCBLabel		*loHistoClass;
	MGAxe			*xAxis;
	MGAxe			*yAxis;
	MCBLabel		*condition;
	
   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
	MGenericHistogramBuilderGUI(const TGWindow *p=0,UInt_t w=500,UInt_t h=300);
#if ROOT_VERSION_CODE <= ROOT_VERSION(5,12,0)
	MGenericHistogramBuilderGUI(const MGenericHistogramBuilderGUI &ap); // constructeur par copie 
#endif
	
	~MGenericHistogramBuilderGUI(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	MGenericHistogramBuilderGUI& operator = (const MGenericHistogramBuilderGUI &hp); // operateur = 
 
	virtual Bool_t ProcessMessage(Long_t msg, Long_t par1, Long_t par2); 

	virtual FEventProcessor *GetFEventProcessor(void)
		{return fept;}
	virtual void SetFEventProcessor(FEventProcessor *f=0)
		{fept=f;}
		
	virtual void NewGenericField(void);
	virtual void BuildHistograms(void);
	virtual void SetListOfHistogramClasses(void);
	virtual void AddEntryToComboBox(MCBLabel *mcb,Char_t *s);
	virtual void AddEntryToComboBox(MCBLabel *mcb, const Char_t *s)
	 {AddEntryToComboBox(mcb,(Char_t *)s);}
	
	virtual void Reset(void);
	virtual void WarningBox(char const *title="Warning",char const *msg="Warning");

        virtual void NewHistos(void) {Emit("NewHistos()");} // *SIGNAL*
        
	ClassDef(MGenericHistogramBuilderGUI,1)
 
}; 
 
#endif 
 
