//
// Classe d'affichage des histogrammes pour la manip Fragmentation
//

#include "ManipFragPlotter.h"
#include "TROOT.h"
#include "TGFrame.h"
#include "TGTab.h"
#include "TRootEmbeddedCanvas.h"
#include "TGLayout.h"
#include "TGButton.h"
#include "TGMenu.h"
#include "Riostream.h"
#include "MCanvasWithMarks.h"

ClassImp(ManipFragPlotter)

//__________________________________________
ManipFragPlotter::ManipFragPlotter(const TGWindow *p,UInt_t w,UInt_t h):
               TGMainFrame(p,w,h)
{
//
// Createur
//

Int_t colTab[2]={0x00FFFF,0xFFFF00};

TGLayoutHints *eX = new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX, 1, 1, 1, 1);
TGLayoutHints *eXeY = new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX| kLHintsExpandY, 1, 1, 1, 1);
TGLayoutHints *fMenuBarItemLayout = new TGLayoutHints(kLHintsTop | kLHintsLeft, 0, 4, 0,0);

this->SetWindowName("Histograms visualization for C12 Fragmentation");
//
// Barre de menus
//
TGMenuBar *mb=new TGMenuBar(this,800,10,kHorizontalFrame);
this->AddFrame(mb,eX);
TGPopupMenu *pum=new TGPopupMenu(gClient->GetRoot());
pum->AddEntry("&Save Pad As...",padSaveAs);
pum->AddEntry("Save C&anvas As...",canvasSaveAs);
pum->AddEntry("Print &Pad",padPrint);
pum->AddEntry("Print &Canvas",canvasPrint);
//pum->AddEntry("&Quit RHB",quitRHB);
pum->Connect("Activated(Int_t)","ManipFragPlotter",
             this,"HandleFileMenu(Int_t)");
mb->AddPopup("&File",pum,fMenuBarItemLayout);

//
// Onglets
//
fTab = new TGTab(this, 800, 600);
fTab->Connect("Selected(Int_t)","ManipFragPlotter",this,"TabSelected(Int_t)");
Int_t nTab=0;
//
// Oscillogrammes
//
TGCompositeFrame *tgcfOsc = fTab->AddTab("OSC");
TGTabElement *tgte = fTab->GetTabTab("OSC");
nTab++;
tgcfOsc->ChangeBackground(colTab[nTab%2]); // Changer la couleur de fond du Canvas
tgte->ChangeBackground(colTab[nTab%2]); // Changer la couleur de fond de l'onglet

TGCompositeFrame *cfOscBout=new TGCompositeFrame(tgcfOsc,800,20,
                                                 kHorizontalFrame |
                                                 kSunkenFrame);
tgcfOsc->AddFrame(cfOscBout,eX);

TRootEmbeddedCanvas *oscCanvas = new TRootEmbeddedCanvas("OSC", tgcfOsc, 800, 600);
Int_t wid = oscCanvas->GetCanvasWindowId();
MCanvasWithMarks *cwm=new MCanvasWithMarks("oCanvas",10,10,wid);
TCanvas *cCan=oscCanvas->GetCanvas();
oscCanvas->AdoptCanvas(cwm);
delete cCan;

tgcfOsc->AddFrame(oscCanvas, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY, 1, 1, 1, 1));

canvasOsc=oscCanvas->GetCanvas();

//
// Monodims
//
TGCompositeFrame *tgcfMonos = fTab->AddTab("Monodims");
tgte = fTab->GetTabTab("Histogrammes");
nTab++;
// // tgcfOsc->ChangeBackground(colTab[nTab%2]); // Changer la couleur de fond du Canvas
tgte->ChangeBackground(colTab[nTab%2]); // Changer la couleur de fond de l'onglet

TGCompositeFrame *cfHistBout=new TGCompositeFrame(tgcfMonos,800,20,
                                                 kHorizontalFrame |
                                                 kSunkenFrame);
tgcfMonos->AddFrame(cfHistBout,eX);

TRootEmbeddedCanvas *histCanvas = new TRootEmbeddedCanvas("Histos", tgcfMonos, 800, 600);
tgcfMonos->AddFrame(histCanvas, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY, 1, 1, 1, 1));
canvasHisto=histCanvas->GetCanvas();
canvasHisto->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",
                     "ManipFragPlotter", this,
                     "DrawEventStatus(Int_t,Int_t,Int_t,TObject*)");
//
// Bidims
//
TGCompositeFrame *tgcfBidims = fTab->AddTab("Bidims");
tgte = fTab->GetTabTab("Bidims");
nTab++;
tgcfBidims->ChangeBackground(colTab[nTab%2]); // Changer la couleur de fond du Canvas
tgte->ChangeBackground(colTab[nTab%2]); // Changer la couleur de fond de l'onglet

TGCompositeFrame *cfBidimBout=new TGCompositeFrame(tgcfBidims,800,20,
                                                 kHorizontalFrame |
                                                 kSunkenFrame);
tgcfBidims->AddFrame(cfBidimBout,eX);

TRootEmbeddedCanvas *bidCanvas = new TRootEmbeddedCanvas("Bidims", tgcfBidims, 800, 600);
tgcfBidims->AddFrame(bidCanvas, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY, 1, 1, 1, 1));
canvasBidims=bidCanvas->GetCanvas();
canvasBidims->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",
                     "ManipFragPlotter", this,
                     "DrawEventStatus(Int_t,Int_t,Int_t,TObject*)");

//
// Triggers
//
TGCompositeFrame *tgcfTrig = fTab->AddTab("Trigger");
tgte = fTab->GetTabTab("Trigger");
nTab++;
tgcfTrig->ChangeBackground(colTab[nTab%2]); // Changer la couleur de fond du Canvas
tgte->ChangeBackground(colTab[nTab%2]); // Changer la couleur de fond de l'onglet

TGCompositeFrame *cfTrigBout=new TGCompositeFrame(tgcfTrig,800,20,
                                                 kHorizontalFrame |
                                                 kSunkenFrame);
tgcfTrig->AddFrame(cfTrigBout,eX);

TRootEmbeddedCanvas *trigCanvas = new TRootEmbeddedCanvas("Trigger", tgcfTrig, 800, 600);
tgcfTrig->AddFrame(trigCanvas, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY, 1, 1, 1, 1));
canvasTrig=trigCanvas->GetCanvas();
canvasTrig->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",
                     "ManipFragPlotter", this,
                     "DrawEventStatus(Int_t,Int_t,Int_t,TObject*)");

//
// Canevas Des controles
//
TGCompositeFrame *tgcfCtrl = fTab->AddTab("Controles");
tgte = fTab->GetTabTab("Controles");
nTab++;
tgcfCtrl->ChangeBackground(colTab[nTab%2]); // Changer la couleur de fond du Canvas
tgte->ChangeBackground(colTab[nTab%2]); // Changer la couleur de fond de l'onglet

TGCompositeFrame *cfCtrlBout=new TGCompositeFrame(tgcfCtrl,800,20,
                                                 kHorizontalFrame |
                                                 kSunkenFrame);
tgcfCtrl->AddFrame(cfCtrlBout,eX);
TRootEmbeddedCanvas *ctrlCanvas = new TRootEmbeddedCanvas("Controles", tgcfCtrl, 800, 600);
tgcfCtrl->AddFrame(ctrlCanvas, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY, 1, 1, 1, 1));
canvasCtrl=ctrlCanvas->GetCanvas();
canvasCtrl->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",
                     "ManipFragPlotter", this,
                     "DrawEventStatus(Int_t,Int_t,Int_t,TObject*)");

TGTextButton *b=new TGTextButton(cfCtrlBout,"thin");
cfCtrlBout->AddFrame(b,eX);
b->Connect("Clicked()","ManipFragPlotter",this,Form("LoadControles(\"%s\")","thin"));
b->Connect("Clicked()","ManipFragPlotter",this,"HighlightCurrentButton()");
b=new TGTextButton(cfCtrlBout,"thick");
cfCtrlBout->AddFrame(b,eX);
b->Connect("Clicked()","ManipFragPlotter",this,Form("LoadControles(\"%s\")","thick"));
b->Connect("Clicked()","ManipFragPlotter",this,"HighlightCurrentButton()");
b=new TGTextButton(cfCtrlBout,"CsI");
cfCtrlBout->AddFrame(b,eX);
b->Connect("Clicked()","ManipFragPlotter",this,Form("LoadControles(\"%s\")","CsI"));
b->Connect("Clicked()","ManipFragPlotter",this,"HighlightCurrentButton()");
b=new TGTextButton(cfCtrlBout,"SiLi/Plast");
cfCtrlBout->AddFrame(b,eX);
b->Connect("Clicked()","ManipFragPlotter",this,Form("LoadControles(\"%s\")","SiLiPlast"));
b->Connect("Clicked()","ManipFragPlotter",this,"HighlightCurrentButton()");



//
// Canevas libre
//
TGCompositeFrame *tgcfLibre = fTab->AddTab("Libre");
tgte = fTab->GetTabTab("Libre");
nTab++;
tgcfLibre->ChangeBackground(colTab[nTab%2]); // Changer la couleur de fond du Canvas
tgte->ChangeBackground(colTab[nTab%2]); // Changer la couleur de fond de l'onglet

TRootEmbeddedCanvas *freeCanvas = new TRootEmbeddedCanvas("Libre", tgcfLibre, 800, 600);
tgcfLibre->AddFrame(freeCanvas, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY, 1, 1, 1, 1));
canvasLibre=freeCanvas->GetCanvas();
canvasLibre->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",
                     "ManipFragPlotter", this,
                     "DrawEventStatus(Int_t,Int_t,Int_t,TObject*)");

//
// Initialisation des boutons
//
TIter next(gROOT->GetList());
TObject *o=0;
while((o=next()))
 {
 if(o->InheritsFrom("TH1"))
  {
  TString hName=o->GetName();
  if(hName.BeginsWith("OSC_"))
   {
   hName.ReplaceAll("OSC_SAMP_","");
   TGTextButton *bout=new TGTextButton(cfOscBout,hName.Data());
   cfOscBout->AddFrame(bout,eX);
   bout->Connect("Clicked()","ManipFragPlotter",this,Form("LoadOscillo(\"%s\")",hName.Data()));
   bout->Connect("Clicked()","ManipFragPlotter",this,"HighlightCurrentButton()");
//    bout=new TGTextButton(cfCtrlBout,hName.Data());
//    cfCtrlBout->AddFrame(bout,eX);
//    bout->Connect("Clicked()","ManipFragPlotter",this,Form("LoadControles(\"%s\")",hName.Data()));
//    bout->Connect("Clicked()","ManipFragPlotter",this,"HighlightCurrentButton()");
   }
  if(hName.BeginsWith("Mono_ADCthin_"))
   {
   hName.ReplaceAll("Mono_ADCthin_","");
   TGTextButton *bout=new TGTextButton(cfHistBout,hName.Data());
   cfHistBout->AddFrame(bout,eX);
   bout->Connect("Clicked()","ManipFragPlotter",this,Form("LoadHistos(\"%s\")",hName.Data()));
   bout->Connect("Clicked()","ManipFragPlotter",this,"HighlightCurrentButton()");
//    bout=new TGTextButton(cfBidimBout,Form("Thk_%s",hName.Data()));
//    cfBidimBout->AddFrame(bout,eX);
//    bout->Connect("Clicked()","ManipFragPlotter",this,Form("LoadTelescopeBidims(\"%s\")",hName.Data()));
//    bout->Connect("Clicked()","ManipFragPlotter",this,"HighlightCurrentButton()");
   if(gROOT->FindObject(Form("RHB_SiThinSiThick_%s",hName.Data()))
      || gROOT->FindObject(Form("RHB_SiThickCsI_%s",hName.Data())))
    {
    bout=new TGTextButton(cfBidimBout,Form("RHB_%s",hName.Data()));
    cfBidimBout->AddFrame(bout,eX);
    bout->Connect("Clicked()","ManipFragPlotter",this,Form("LoadTelescopeBidims(\"%s\")",hName.Data()));
    bout->Connect("Clicked()","ManipFragPlotter",this,"HighlightCurrentButton()");
    }
   bout=new TGTextButton(cfBidimBout,Form("FASTER_%s",hName.Data()));
   cfBidimBout->AddFrame(bout,eX);
   bout->Connect("Clicked()","ManipFragPlotter",this,Form("LoadTelescopeBidims(\"%s\")",hName.Data()));
   bout->Connect("Clicked()","ManipFragPlotter",this,"HighlightCurrentButton()");
   bout=new TGTextButton(cfTrigBout,Form("FASTER_%s",hName.Data()));
   cfTrigBout->AddFrame(bout,eX);
   bout->Connect("Clicked()","ManipFragPlotter",this,Form("LoadTelescopeTrigger(\"%s\")",hName.Data()));
   bout->Connect("Clicked()","ManipFragPlotter",this,"HighlightCurrentButton()");
   }
  if(hName.BeginsWith("Mono_ADC_SiLiGANIL"))
   {
   TGTextButton *bout=new TGTextButton(cfHistBout,"SiLi/Plast");   
   cfHistBout->AddFrame(bout,eX);
   bout->Connect("Clicked()","ManipFragPlotter",this,"LoadHistos(\"SiLi/Plast\")");
   bout->Connect("Clicked()","ManipFragPlotter",this,"HighlightCurrentButton()");
   }
  }
 }

//
// Barre de status
//

statusBar =new TGStatusBar(this,800,20);
Int_t parts[]={30,20,10,40};
statusBar->SetParts(parts,4);

//
// Afficher les elements
//

this->AddFrame(fTab, eXeY);  
this->AddFrame(statusBar, eX);  
// // tgcfOsc->MapSubwindows();
tgcfMonos->MapSubwindows();
tgcfCtrl->MapSubwindows();
fTab->MapSubwindows();
this->MapSubwindows();
this->Resize(this->GetDefaultSize());
this->MapWindow();

fTab->Selected(0);

//
// Mise a jour du tableau des boutons actifs
//
curBout.Expand(nTab);
for(Int_t i=0;i<nTab;i++)
 {
 curBout[i]=0;
 }
}

//__________________________________________
ManipFragPlotter::~ManipFragPlotter()
{
// Destructeur
}

//__________________________________________
void ManipFragPlotter::LoadOscillo(const Char_t *name)
{
//
// Chargement d'un oscillogramme
//
TObject *o=(TObject *)gTQSender;
if(o->InheritsFrom("TGTextButton"))
 {
 TGTextButton *b=(TGTextButton *)o;
 TString hName= b->GetString();
 hName.Prepend("OSC_SAMP_");
 cout << "Histo : " <<hName.Data() << endl;
 o=gROOT->FindObject(hName.Data());
 if(o)
  {
  canvasOsc->cd();
  canvasOsc->SetGridx(kTRUE);
  canvasOsc->SetGridy(kTRUE);
  o->Draw();
  }
 }
}

//__________________________________________
void ManipFragPlotter::LoadControles(const Char_t *name)
{
//
// Chargement d'un oscillogramme
//
TObject *o=(TObject *)gTQSender;
if(o->InheritsFrom("TGTextButton"))
 {
 TGTextButton *b=(TGTextButton *)o;
 TString hName= b->GetString();
 this->LoadControlesHistos(hName.Data());
 }
}

//__________________________________________
void ManipFragPlotter::LoadHistos(const Char_t *name)
{
//
// Chargement de histogrammes
//
TObject *o=(TObject *)gTQSender;
if(o->InheritsFrom("TGTextButton"))
 {
 TGTextButton *b=(TGTextButton *)o;
 TString hName= b->GetString();
 if(hName.BeginsWith("tel"))
  {
  this->LoadTelescopeMonos(hName.Data());
  }
 if(hName == "SiLi/Plast")
  {
  this->LoadSiLiPlastMonos();
  }
 }
}

#include "TFrame.h"

//__________________________________________
void ManipFragPlotter::LoadTelescopeMonos(const Char_t *name)
{
//
// Chargement des histos monos d'un telescope
//
   Int_t nPad=canvasHisto->GetListOfPrimitives()->GetSize();
   if(nPad != 6)
    {
    canvasHisto->Clear();
    canvasHisto->Divide(2,3,0.001,0.001);
    for(Int_t i=1;i<=6;i++)
     {
     TPad *cp=(TPad *)canvasHisto->cd(i);
     cp->SetBit(TPad::kCannotMove);
     }
    }
   TObject *o=gROOT->FindObject(Form("Mono_ADCthin_%s",name));
   canvasHisto->cd(1);if(o)o->Draw();
   canvasHisto->cd(3);
   o=gROOT->FindObject(Form("Mono_ADCthick_%s",name));
   if(o)o->Draw();
   canvasHisto->cd(2);
   o=gROOT->FindObject(Form("Mono_QDC1_%s",name));
   if(o)o->Draw();
   canvasHisto->cd(4);
   o=gROOT->FindObject(Form("Mono_QDC2_%s",name));
   if(o)o->Draw();
   canvasHisto->cd(6);
   o=gROOT->FindObject(Form("Mono_QDC3_%s",name));
   if(o)o->Draw();
   
   canvasHisto->cd();
}

#include "TH1.h"
#include "TPaveStats.h"

//__________________________________________
void ManipFragPlotter::LoadTelescopeBidims(const Char_t *name)
{
//
// Chargement des histos monos d'un telescope
//
 TObject *o=(TObject *)gTQSender;
 if(o->InheritsFrom("TGTextButton"))
  {
  TGTextButton *b=(TGTextButton *)o;
  TString hName= b->GetString();
  cout << "Chargement des bidims pour " <<  hName.Data() << endl;
  if(hName.Contains("_tel"))
   {
   Int_t index=hName.Index("_");
   TString sTrig=hName(0,index);
   hName.ReplaceAll(sTrig.Data(),"");
   hName.ReplaceAll("_","");
   TString snTel=hName;
   snTel.ReplaceAll("tel","");
   Int_t numTel=snTel.Atoi();
   cout << sTrig.Data() << " / " << hName.Data() << " / " << numTel << endl;
   Int_t nPad=canvasBidims->GetListOfPrimitives()->GetSize();
   if(nPad != 4)
    {
    canvasBidims->Clear();
    canvasBidims->Divide(2,2,0.001,0.001);
    for(Int_t i=1;i<=4;i++)
     {
     TPad *cp=(TPad *)canvasBidims->cd(i);
     cp->SetBit(TPad::kCannotMove);
     }
    }
   TPaveStats *ps=0;
   TH1 *o=0;
   canvasBidims->cd(1);
   if(sTrig=="FASTER")
    o=(TH1 *)gROOT->FindObject(Form("SiThinSiThick_%s",hName.Data()));
   else
    o=(TH1 *)gROOT->FindObject(Form("%s_SiThinSiThick_%s",sTrig.Data(),hName.Data()));
   if(o){o->Draw();gPad->Modified();gPad->Update();
   ps=(TPaveStats *)o->GetFunction("stats");if(ps) ps->SetOptStat(10011);}else{gPad->Clear();}
   canvasBidims->cd(2);
   if(sTrig=="FASTER")
    o=(TH1 *)gROOT->FindObject(Form("SiThickCsI_%s",hName.Data()));
   else
    o=(TH1 *)gROOT->FindObject(Form("%s_SiThickCsI_%s",sTrig.Data(),hName.Data()));
   if(o){o->Draw();gPad->Modified();gPad->Update();
   ps=(TPaveStats *)o->GetFunction("stats");if(ps) ps->SetOptStat(10011);}else{gPad->Clear();}
   canvasBidims->cd(3);
   o=(TH1 *)gROOT->FindObject(Form("CsIRapLent_tel%d",numTel));
   if(o){o->Draw();gPad->Modified();gPad->Update();
   ps=(TPaveStats *)o->GetFunction("stats");if(ps) ps->SetOptStat(10011);}else{gPad->Clear();}
   canvasBidims->cd(4);
   o=(TH1 *)gROOT->FindObject(Form("DiffTSTel%d",numTel));
   if(o){o->Draw();gPad->SetLogz(kTRUE);gPad->Modified();gPad->Update();
   ps=(TPaveStats *)o->GetFunction("stats");
   if(ps) ps->SetOptStat(10011);}else{gPad->SetLogz(kFALSE);gPad->Clear();}
   
//    canvasBidims->cd(4);
//    o=(TH1 *)gROOT->FindObject(Form("trigThinCsITel%d",numTel));
//    if(o){o->Draw();o->Draw("same,text");gPad->Modified();gPad->Update();
//    ps=(TPaveStats *)o->GetFunction("stats");if(ps) ps->SetOptStat(10011);}else{gPad->Clear();}
   canvasBidims->cd();
   }
  }
}

//__________________________________________
void ManipFragPlotter::LoadTelescopeTrigger(const Char_t *name)
{
//
// Chargement des histos monos d'un telescope
//
 TObject *o=(TObject *)gTQSender;
 if(o->InheritsFrom("TGTextButton"))
  {
  TGTextButton *b=(TGTextButton *)o;
  TString hName= b->GetString();
  cout << "Chargement des bidims pour " <<  hName.Data() << endl;
  if(hName.Contains("_tel"))
   {
   Int_t index=hName.Index("_");
   TString sTrig=hName(0,index);
   hName.ReplaceAll(sTrig.Data(),"");
   hName.ReplaceAll("_","");
   TString snTel=hName;
   snTel.ReplaceAll("tel","");
   Int_t numTel=snTel.Atoi();
   cout << sTrig.Data() << " / " << hName.Data() << " / " << numTel << endl;
   Int_t nPad=canvasTrig->GetListOfPrimitives()->GetSize();
   if(nPad != 2)
    {
    canvasTrig->Clear();
    canvasTrig->Divide(2,1,0.001,0.001);
    TPad *p=(TPad *)canvasTrig->cd(1);
    p->Divide(1,2,0.001,0.001);
    for(Int_t i=1;i<=2;i++)
     {
     TPad *cp=(TPad *)canvasTrig->cd(i);
     cp->SetBit(TPad::kCannotMove);
     cp=(TPad *)p->cd(i);
     cp->SetBit(TPad::kCannotMove);
     }
    }
   TPaveStats *ps=0;
   TH1 *o=0;
   TPad *p=(TPad *)canvasTrig->cd(1);
   p->cd(1);
   o=(TH1 *)gROOT->FindObject(Form("DiffTSTTTel%d",numTel));
   if(o) {o->Draw();gPad->Modified();gPad->Update();}else gPad->Clear();
   p->cd(2);
   o=(TH1 *)gROOT->FindObject(Form("DiffTSTCTel%d",numTel));
   if(o) {o->Draw();gPad->Modified();gPad->Update();}else gPad->Clear();
   canvasTrig->cd(2);
   o=(TH1 *)gROOT->FindObject(Form("DiffTSTel%d",numTel));
   if(o){o->Draw();gPad->SetLogz(kTRUE);gPad->Modified();gPad->Update();
   ps=(TPaveStats *)o->GetFunction("stats");
   if(ps) ps->SetOptStat(10011);}else{gPad->SetLogz(kFALSE);gPad->Clear();}
   canvasTrig->cd();
   }
  }
}

//__________________________________________
void ManipFragPlotter::LoadSiLiPlastMonos(const Char_t *name)
{
//
// Chargement des histos SiLi/Plastique
//
   Int_t nPad=canvasHisto->GetListOfPrimitives()->GetSize();
   if(nPad != 6)
    {
    canvasHisto->Clear();
    canvasHisto->Divide(2,3,0.001,0.001);
    for(Int_t i=1;i<=6;i++)
     {
     TPad *cp=(TPad *)canvasHisto->cd(i);
     cp->SetBit(TPad::kCannotMove);
     }
    }
   TObject *o=gROOT->FindObject("Mono_ADC_SiLiGANIL");
   canvasHisto->cd(1);if(o)o->Draw();
   canvasHisto->cd(3);
   o=gROOT->FindObject("Mono_ADC_SiLi2");if(o)o->Draw();
   canvasHisto->cd(2);
   o=gROOT->FindObject("Mono_QDC1_Plast");if(o)o->Draw();
   canvasHisto->cd(4);
   o=gROOT->FindObject("Mono_QDC2_Plast");if(o)o->Draw();
   canvasHisto->cd(6);
   o=gROOT->FindObject("Mono_QDC3_Plast");if(o)o->Draw();
   for(Int_t i=1;i<=6;i++)
    {
    TPad *cp=(TPad *)canvasHisto->cd(i);
    TFrame *f=cp->GetFrame();
    f->SetBit(TBox::kCannotMove);
    }
   canvasHisto->cd();

}

//__________________________________________
void ManipFragPlotter::LoadControlesHistos(const Char_t *name)
{
//
// Chargement des histos de controle
//
   TObject *o=0;
   Int_t nPad=canvasCtrl->GetListOfPrimitives()->GetSize();
   TString hName=name;
   if(hName.Contains("thin") || hName.Contains("thick"))
    {
    if(nPad != 4)
     {
     canvasCtrl->Clear();
     canvasCtrl->Divide(2,2,0.001,0.001);
     for(Int_t i=1;i<=4;i++)
      {
      TPad *cp=(TPad *)canvasCtrl->cd(i);
      cp->SetBit(TPad::kCannotMove);
      }
     }
    cout << "Controles : " << Form("CtrlCalcADC%s",name) << endl;
   
    canvasCtrl->cd(1);o=gROOT->FindObject(Form("CtrlCalcADC%s",name));
     if(o){((TH1 *)o)->SetStats(kFALSE);o->Draw();}
    canvasCtrl->cd(2);o=gROOT->FindObject(Form("CtrlSendADC%s",name));
     if(o){((TH1 *)o)->SetStats(kFALSE);o->Draw();}
    canvasCtrl->cd(3);o=gROOT->FindObject(Form("CtrlTrigADC%s",name));
     if(o){((TH1 *)o)->SetStats(kFALSE);o->Draw();}
    }
   else if(hName.Contains("CsI"))
    {
    if(nPad != 2)
     {
     canvasCtrl->Clear();
     canvasCtrl->Divide(1,2,0.001,0.001);
     for(Int_t i=1;i<=2;i++)
      {
      TPad *cp=(TPad *)canvasCtrl->cd(i);
      cp->SetBit(TPad::kCannotMove);
      }
     }
    canvasCtrl->cd(1);o=gROOT->FindObject(Form("CtrlCalc%s",name));
     if(o){((TH1 *)o)->SetStats(kFALSE);o->Draw();}
    canvasCtrl->cd(2);o=gROOT->FindObject(Form("CtrlSend%s",name));
     if(o){((TH1 *)o)->SetStats(kFALSE);o->Draw();}
    }
   else
    {
    if(nPad != 4)
     {
     canvasCtrl->Clear();
     canvasCtrl->Divide(2,2,0.001,0.001);
     for(Int_t i=1;i<=4;i++)
      {
      TPad *cp=(TPad *)canvasCtrl->cd(i);
      cp->SetBit(TPad::kCannotMove);
      }
     }
    canvasCtrl->cd(1);o=gROOT->FindObject("CtrlSiLiPlast");
     if(o){((TH1 *)o)->SetStats(kFALSE);o->Draw();}
    canvasCtrl->cd(2);o=gROOT->FindObject("CtrlRateSiLi");
     if(o){((TH1 *)o)->SetStats(kFALSE);o->Draw();}
    canvasCtrl->cd(3);o=gROOT->FindObject("CtrlISiLi2");
     if(o){((TH1 *)o)->SetStats(kFALSE);o->Draw();}
    canvasCtrl->cd(4);o=gROOT->FindObject("CtrlParasites");
     if(o){((TH1 *)o)->SetStats(kFALSE);o->Draw();}
    }
   canvasCtrl->cd();

}

//__________________________________________
void ManipFragPlotter::TabSelected(Int_t id)
{
//
// Selection d'un tab et activation du canvas correspondant
//
TGTabElement *tabe=fTab->GetTabTab(id);
TString tName=tabe->GetString();
cout << "Tab " << tName.Data() << " selectionne..." << endl;
if(tName=="OSC")
 {
 canvasOsc->cd();
 currentCanvas=canvasOsc;
 for(Int_t i=0;i<4;i++)
  {
  statusBar->SetText("",i);
  }
 }
if(tName=="Monodims")
 {
 canvasHisto->cd();
 currentCanvas=canvasHisto;
 }
else if(tName=="Bidims")
 {
 canvasBidims->cd();
 currentCanvas=canvasBidims;
 }
else if(tName=="Controles")
 {
 canvasCtrl->cd();
 currentCanvas=canvasCtrl;
 }
else if(tName=="Libre")
 {
 canvasLibre->cd();
 currentCanvas=canvasLibre;
 }
else if(tName=="Trigger")
 {
 canvasTrig->cd();
 currentCanvas=canvasTrig;
 }
statusBar->SetText(Form("Tab %s selectionne...",tName.Data()),0);
}

#include "TSystem.h"
#include "TGFileDialog.h"

static const char *gSaveAsTypes[] = { "PostScript",   "*.ps",
                                      "Encapsulated PostScript", "*.eps",
                                      "PDF",          "*.pdf",
                                      "SVG",          "*.svg",
                                      "GIF",          "*.gif",
                                      //"ROOT macros",  "*.C",
                                      "ROOT files",   "*.root",
                                      "XML",          "*.xml",
                                      "PNG",          "*.png",
                                      "XPM",          "*.xpm",
                                      "JPEG",         "*.jpg",
                                      "TIFF",         "*.tiff",
                                      "XCF",          "*.xcf",
                                      0,              0 };


#include "TApplication.h"

//__________________________________________
void ManipFragPlotter::HandleFileMenu(Int_t menuItem)
{
//
// Gestion du menu "File"
//
cout << "item " << menuItem << " de menu \"File\" active..." << endl;
TPad *printPad=0;
switch(menuItem)
 {
 case padSaveAs : 
          cout << "     Save Pad As..." << endl;
          printPad = (TPad *)gPad;
 case canvasSaveAs : 
          if(!printPad)
           {
           printPad=gPad->GetCanvas();
           cout << "     Save Canvas As..." << endl;
	   }
          static TString dir(".");
          static Int_t typeidx = 0;
          static Bool_t overwr = kFALSE;
          static TGFileInfo fi;
          fi.fFileTypes   = gSaveAsTypes;
          fi.fIniDir	  = StrDup(dir);
          fi.fFileTypeIdx = typeidx;
          fi.fOverwrite   = overwr;
          new TGFileDialog(fClient->GetDefaultRoot(), this, kFDSave, &fi);
          if (fi.fFilename) {
           TString fn = fi.fFilename;
           TString ft = fi.fFileTypes[fi.fFileTypeIdx+1];
           dir	   = fi.fIniDir;
           typeidx = fi.fFileTypeIdx;
           overwr  = fi.fOverwrite;
           if (fn.EndsWith(".root") ||
               fn.EndsWith(".ps")   ||
               fn.EndsWith(".eps")  ||
               fn.EndsWith(".pdf")  ||
               fn.EndsWith(".svg")  ||
               fn.EndsWith(".gif")  ||
               fn.EndsWith(".C")    ||
               fn.EndsWith(".cxx")  ||
               fn.EndsWith(".xml")  ||
               fn.EndsWith(".xpm")  ||
               fn.EndsWith(".jpg")  ||
               fn.EndsWith(".png")  ||
               fn.EndsWith(".xcf")  ||
               fn.EndsWith(".tiff")) {
          	printPad->SaveAs(fn);
           } else if (!fn.EndsWith(".")) {
	      ft.ReplaceAll("*","");
	      fn.Append(ft.Data());
	      printPad->SaveAs(fn);
	   }  else {
              Warning("HandleFileMenu", "file %s cannot be saved with this extension", fi.fFilename);
           }
	  }
          break;
 
 case padPrint : 
          cout << "      Print Pad..." << endl;
          printPad=(TPad *)gPad;
 case canvasPrint : 
          if(!printPad)
           {
           printPad=gPad->GetCanvas();
	   cout << "      Print Canvas..." << endl;
	   }
          printPad->SaveAs("tmp.ps");
	  gSystem->Exec(Form("%s tmp.ps",gSystem->Getenv("VISUPRINT")));
          break;
 case quitRHB :
          if(gApplication)
	   {
	   cout << "Quit RHB" << endl;
	   gApplication->Terminate(0);
           }
          break;
 }

}

//__________________________________________
void ManipFragPlotter::HighlightCurrentButton(void)
{
//
// Met en valeur le dernier bouton clique
//
 TObject *o=(TObject *)gTQSender;
 TGButton *bout=0;
 Int_t numTab=fTab->GetCurrent();
 if(o->InheritsFrom("TGButton"))
  {
  bout=(TGButton *)curBout[numTab];
  if(bout)
   {
   bout->SetBackgroundColor(boutCol);
   }
  bout=(TGButton *)o;
  boutCol=bout->GetBackground();
  bout->SetBackgroundColor(0xFF0000);
  curBout[numTab]=bout;
  this->Layout();
  } 

}

//______________________________________________________________________________
void ManipFragPlotter::DrawEventStatus(Int_t event, Int_t px, Int_t py, TObject *selected)
{
   // Report name and title of primitive below the cursor.
   //
   //    This function is called when the option "Event Status"
   //    in the canvas menu "Options" is selected.

   const Int_t kTMAX=256;
   static char atext[256];

   if (!selected) return;

   TVirtualPad* savepad;
   savepad = gPad;
   gPad = currentCanvas->GetSelectedPad();

   statusBar->SetText(selected->GetTitle(),0);
   statusBar->SetText(selected->GetName(),1);
   if (event == kKeyPress)
      snprintf(atext, kTMAX, "%c", (char) px);
   else
      snprintf(atext, kTMAX, "%d,%d", px, py);
   statusBar->SetText(atext,2);
   statusBar->SetText(selected->GetObjectInfo(px,py),3);
   gPad = savepad;
}
